/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: Writer.java,v 1.1.2.5 2000/02/13 03:41:09 pmahar Exp $
 */

package org.enhydra.ide.jbuilder.common.capture;

import java.io.StringWriter;
import java.util.Vector;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class Writer extends StringWriter {
    private Vector writeListeners = new Vector();
    private boolean buffered = false;
    private boolean newLine  = false;
    private StringBuffer lineBuffer = new StringBuffer();
    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public Writer() {}

    public void setLineBuffered(boolean b) {
      buffered = b;
   }

    public boolean isLineBuffered() {
      return buffered;
    }

    /**
     * Method declaration
     *
     *
     * @param c
     *
     * @see
     */
    public synchronized void write(int c) {
	char[] ca = new char[1];

	ca[0] = (char) c;

	String cs = new String(ca);
	write(cs);
    }

    /**
     * Method declaration
     *
     *
     * @param str
     *
     * @see
     */
    public synchronized void write(String str) {
//      if (isLineBuffered()) {
//        if (str != null && str.trim().length() > 0) {
//          write(str, 0, str.length());
//        }
//      } else {
        write(str, 0, str.length());
//      }
    }

    /**
     * Method declaration
     *
     *
     * @param str
     *
     * @see
     */
    public synchronized void writeln(String str) {
      newLine = true;
      write(str + "\n");
      newLine = false;
    }

    /**
     * Method declaration
     *
     *
     * @param str
     * @param off
     * @param len
     *
     * @see
     */
    public synchronized void write(String str, int off, int len) {
        String out = str.substring(off, (off+len));
        boolean writeLine = false;
        if (isLineBuffered()) {
          if (out.length() > 1) {
            char end1 = out.charAt(out.length()-2);
            char end2 = out.charAt(out.length()-1);
            if ((int)end1 == 13 && (int)end2 == 10) {
              if (out.length() < 3) {
                out = "";
              } else {
                out = out.substring(0, out.length()-3);
              }
              writeLine = true;
            }
            if (out.endsWith("\n")) {
              writeLine = true;
            }
          }
          if (writeLine) {
     	    notifyWriteListeners(lineBuffer.toString() + out);
            lineBuffer = new StringBuffer();
          } else {
            lineBuffer.append(out);
          }
        } else {
  	  notifyWriteListeners(out);
        }
    }

    // event methods

    /**
     * Method declaration
     *
     *
     * @param l
     *
     * @see
     */
    public synchronized void addWriteListener(WriteListener l) {
	writeListeners.addElement(l);
    }

    /**
     * Method declaration
     *
     *
     * @param l
     *
     * @see
     */
    public synchronized void removeWriteListener(WriteListener l) {
	if (writeListeners.contains(l)) {
	    writeListeners.removeElement(l);
	}
    }

    /**
     * Method declaration
     *
     *
     * @param s
     *
     * @see
     */
    private synchronized void notifyWriteListeners(String s) {
	int	      count = 0;
	WriteListener listener = null;
	WriteEvent    event = new WriteEvent(this, WriteEvent.OUTPUT, s);

	count = writeListeners.size();

	for (int i = 0; i < count; i++) {
	    listener = (WriteListener) writeListeners.elementAt(i);

	    listener.onWrite(event);
	}
    }

}



/*--- formatting done in "Sun Java Convention" style on 01-16-2000 ---*/

