/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: NewMappingDialog.java,v 1.1.2.4 2000/02/13 03:41:12 pmahar Exp $
 */
package org.enhydra.ide.jbuilder.common.wizard.xmlc;

import org.enhydra.devsys.swing.DirectoryFilter;
import org.enhydra.devsys.swing.GridBagConstraintsX;
import org.enhydra.devsys.swing.SwingUtil;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.beans.*;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class NewMappingDialog extends JDialog {
    public static final int     ACTION_OK = 0;
    public static final int     ACTION_CANCEL = 1;
    private static File		startFolder = null;
    private int			option = ACTION_CANCEL;
    private LocalButtonListener buttonListener = null;
    private JPanel		panelMain = new JPanel();
    private GridBagLayout       layoutMain;
    private JPanel		panelEntry;
    private GridBagLayout       layoutEntry;
    private JPanel		panelButtons;
    private GridBagLayout       layoutButton;
    private JLabel		labelFolder;
    private JLabel		jLabel1;
    private JTextField		textFolder;
    private JButton		buttonBrowse;
    private JLabel		labelPackage;
    private JTextField		textPackage;
    private JButton		jButton1;
    private JButton		jButton2;
    private JButton		buttonCancel;
    private JButton		buttonOK;

    /**
     * Constructor declaration
     *
     *
     * @param owner
     * @param title
     * @param modal
     *
     * @see
     */
    public NewMappingDialog(JDialog owner, String title, boolean modal) {
	super(owner, title, modal);

	try {
	    jbInit();
	    pmInit();
	    pack();
	} catch (Exception ex) {
	    ex.printStackTrace();
	}
    }

    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public NewMappingDialog() {
	this(null, "", false);
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    public void show() {
	setResizable(false);

	Point cPoint;

	invalidate();
	doLayout();
	pack();

	cPoint = SwingUtil.getCenteringPoint(getSize());

	setLocation(cPoint);
	super.show();
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void pmInit() {
	buttonListener = new LocalButtonListener();

	buttonBrowse.addActionListener(buttonListener);
	buttonOK.addActionListener(buttonListener);
	buttonCancel.addActionListener(buttonListener);
	textFolder.setText(new String());
	textPackage.setText(new String());
    }

    /**
     * Method declaration
     *
     *
     * @throws Exception
     *
     * @see
     */
    private void jbInit() throws Exception {
	layoutMain =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	panelEntry = (JPanel) Beans.instantiate(getClass().getClassLoader(),
						JPanel.class.getName());
	layoutEntry =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	panelButtons = (JPanel) Beans.instantiate(getClass().getClassLoader(),
						  JPanel.class.getName());
	layoutButton =
	    (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
					      GridBagLayout.class.getName());
	labelFolder = (JLabel) Beans.instantiate(getClass().getClassLoader(),
						 JLabel.class.getName());
	jLabel1 = (JLabel) Beans.instantiate(getClass().getClassLoader(),
					     JLabel.class.getName());
	textFolder =
	    (JTextField) Beans.instantiate(getClass().getClassLoader(),
					   JTextField.class.getName());
	buttonBrowse =
	    (JButton) Beans.instantiate(getClass().getClassLoader(),
					JButton.class.getName());
	labelPackage = (JLabel) Beans.instantiate(getClass().getClassLoader(),
						  JLabel.class.getName());
	textPackage =
	    (JTextField) Beans.instantiate(getClass().getClassLoader(),
					   JTextField.class.getName());
	jButton1 = (JButton) Beans.instantiate(getClass().getClassLoader(),
					       JButton.class.getName());
	jButton2 = (JButton) Beans.instantiate(getClass().getClassLoader(),
					       JButton.class.getName());
	buttonCancel =
	    (JButton) Beans.instantiate(getClass().getClassLoader(),
					JButton.class.getName());
	buttonOK = (JButton) Beans.instantiate(getClass().getClassLoader(),
					       JButton.class.getName());

	panelMain.setLayout(layoutMain);
	panelEntry.setLayout(layoutEntry);
	panelButtons.setLayout(layoutButton);
	labelFolder.setText("Source Folder:");
	jLabel1.setText("jLabel1");
	textFolder.setPreferredSize(new Dimension(250, 21));
	textFolder.setText("jTextField1");
	buttonBrowse.setText("Browse...");
	labelPackage.setText("Package Name::");
	textPackage.setPreferredSize(new Dimension(250, 21));
	textPackage.setText("jTextField2");
	jButton1.setText("jButton1");
	jButton2.setText("jButton1");
	buttonCancel.setText("Cancel");
	buttonOK.setText("OK");
	getContentPane().add(panelMain);
	panelMain.add(panelEntry,
		      new GridBagConstraintsX(0, 0, 1, 1, 0.2, 0.2,
					     GridBagConstraints.CENTER,
					     GridBagConstraints.BOTH,
					     new Insets(0, 0, 0, 0), 0, 0));
	panelEntry.add(labelFolder,
		       new GridBagConstraintsX(0, 0, 1, 1, 0.2, 0.2,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 0, 0));
	panelEntry.add(textFolder,
		       new GridBagConstraintsX(0, 1, 1, 1, 0.4, 0.4,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 200,
					      0));
	panelEntry.add(buttonBrowse,
		       new GridBagConstraintsX(1, 1, 1, 1, 0.2, 0.2,
					      GridBagConstraints.CENTER,
					      GridBagConstraints.NONE,
					      new Insets(5, 5, 5, 5), 0, 0));
	panelEntry.add(labelPackage,
		       new GridBagConstraintsX(0, 2, 1, 1, 0.2, 0.2,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 0, 0));
	panelEntry.add(textPackage,
		       new GridBagConstraintsX(0, 3, 1, 1, 0.4, 0.4,
					      GridBagConstraints.WEST,
					      GridBagConstraints.HORIZONTAL,
					      new Insets(5, 5, 5, 5), 200,
					      0));
	panelMain.add(panelButtons,
		      new GridBagConstraintsX(0, 1, 1, 1, 0.2, 0.2,
					     GridBagConstraints.CENTER,
					     GridBagConstraints.BOTH,
					     new Insets(5, 5, 5, 0), 0, 0));
	panelButtons.add(buttonOK,
			 new GridBagConstraintsX(0, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER,
						GridBagConstraints.NONE,
						new Insets(5, 5, 5, 5), 0,
						0));
	panelButtons.add(buttonCancel,
			 new GridBagConstraintsX(1, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER,
						GridBagConstraints.NONE,
						new Insets(5, 5, 5, 5), 0,
						0));
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    protected void closeDialog() {
	setVisible(false);
	removeAll();
	dispose();
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected int getOption() {
	return option;
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected String getFolder() {
	return textFolder.getText();
    }

    /**
     * Method declaration
     *
     *
     * @return
     *
     * @see
     */
    protected String getPackageName() {
	return textPackage.getText();
    }

    /**
     * Method declaration
     *
     *
     * @param o
     *
     * @see
     */
    private void setOption(int o) {
	option = o;
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    private void browseAction() {
	File choice;

	if (startFolder == null ||!startFolder.exists()) {
	    startFolder = new File(textFolder.getText());
	}

	choice =
	    SwingUtil.getDirectoryChoice(this, startFolder,
					 "Select folder to map into a package");

	buttonBrowse.requestFocus();

	if (choice != null) {
	    textFolder.setText(choice.toString());

	    startFolder = choice;    // persist this choice for next call
	}
    }

    /**
     * Class declaration
     *
     *
     * @author
     * @version %I%, %G%
     */
    class LocalButtonListener implements ActionListener {

	/**
	 * Method declaration
	 *
	 *
	 * @param event
	 *
	 * @see
	 */
	public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();

	    if (source == buttonBrowse) {
		browseAction();
	    } else if (source == buttonOK) {
		setOption(ACTION_OK);
		closeDialog();
	    } else if (source == buttonCancel) {
		setOption(ACTION_CANCEL);
		closeDialog();
	    }
	}

    }

}



/*--- formatting done in "Sun Java Convention" style on 01-16-2000 ---*/

