/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: XMLCPanel.java,v 1.1.2.5 2000/02/13 03:41:12 pmahar Exp $
 */

package org.enhydra.ide.jbuilder.common.wizard.xmlc;

import org.enhydra.xml.xmlc.XMLCException;
import org.enhydra.ide.jbuilder.common.node.OtterXMLCNode;
import org.enhydra.ide.jbuilder.common.capture.Writer;
import org.enhydra.ide.jbuilder.common.capture.WriteEvent;
import org.enhydra.ide.jbuilder.common.capture.WriteListener;
import java.io.File;
import java.util.Vector;

/**
 * Class declaration
 *
 *
 * @author
 * @version %I%, %G%
 */
public class XMLCPanel extends CompilePanel {
    private CompileThread compileThread = null;
    private Vector	  writeListeners = new Vector();

    /**
     * Constructor declaration
     *
     *
     * @see
     */
    public XMLCPanel() {}

    /**
     * Method declaration
     *
     *
     * @see
     */
    protected void startCompile() {
	if (compileThread != null) {
	    compileThread.expire();
	}

	WriteListener[] wl = new WriteListener[writeListeners.size()];

	for (int i = 0; i < writeListeners.size(); i++) {
	    wl[i] = (WriteListener) writeListeners.elementAt(i);
	}

	compileThread = new CompileThread(wl);

	compileThread.setProject(getProject());
	compileThread.setNodes(getNodes());
	compileThread.start();
    }

    /**
     * Method declaration
     *
     *
     * @param l
     *
     * @see
     */
    public synchronized void addWriteListener(WriteListener l) {
	writeListeners.addElement(l);
    }

    /**
     * Method declaration
     *
     *
     * @param l
     *
     * @see
     */
    public synchronized void removeWriteListener(WriteListener l) {
	if (writeListeners.contains(l)) {
	    writeListeners.removeElement(l);
	}
    }

    /**
     * Method declaration
     *
     *
     * @see
     */
    protected void fillLists() {
	int	   count = getNodes().length;
	OtterXMLCNode source = null;

	for (int i = 0; i < count; i++) {
	    source = getNodes()[i];

            if (source.isCompileSelected()) {
	       getModelSelected().addElement(source.getFilename());
	    } else {
	        getModelAvailable().addElement(source.getFilename());
	    }
	}
    }

}



/*--- formatting done in "Sun Java Convention" style on 01-16-2000 ---*/

