/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *
 * $Id: WinFolderNode.java,v 1.1.2.6 2000/02/13 03:41:15 pmahar Exp $
 */

package org.enhydra.ide.jbuilder.win32.node;

import org.enhydra.ide.jbuilder.common.node.OtterFolderNode;
import org.enhydra.ide.jbuilder.common.node.OtterNode;
import org.enhydra.ide.jbuilder.common.node.OtterProject;
import com.borland.jbuilder.addin.Project;
import com.borland.jbuilder.addin.Url;
import java.io.File;

/**
 * WinFolderNode represents a folder in a Win32 JBuilder project file.
 *
 * @author
 * Paul Mahar
 * @version %I%, %G%
 */
public class WinFolderNode extends WinNode implements OtterFolderNode {

    /**
     * Create a new folder in a project. While I did get this
     * method to create folders, I could not successfully add
     * anything to them so I stubbed the create out.
     *
     * @param otterProject
     * The Win32 JBuilder project.
     * @param otterNode
     * The parent node for the folder
     * @param name
     * The name for the new folder.
     *
     */
    public WinFolderNode(OtterProject otterProject, OtterNode otterNode,
			 String name) {
	Url				   url = null;
	com.borland.jbuilder.addin.Project nativeProject = null;
	WinProject			   winProject = null;

	if (otterProject.getNativeProject() instanceof Project) {
	    nativeProject = (Project) otterProject.getNativeProject();
	}

	if (otterProject instanceof WinProject) {
	    winProject = (WinProject) otterProject;
	}
        // Can't figure out how to create or use folders in
        // Win32 JBuilder, so just ingore this create.
        setNativeNode(nativeProject);
    }

}



/*--- formatting done in "Sun Java Convention" style on 01-16-2000 ---*/

